#include "BBorder.h"

BBorder :: BBorder(BView *parent, BRect frame, const char *name, ulong resizingMode, char *l)
	: BView(frame, name, resizingMode, B_WILL_DRAW|B_FULL_UPDATE_ON_RESIZE), begin(10)
{
	font_info fntinf;
	
	parent->AddChild(this);	
	SetViewColor(parent->ViewColor());
	SetFontName("Emily");
	
	textLen=StringWidth(l);
	label=l;

	GetFontInfo(&fntinf);	
	
	innerView = new BView(BRect(3,fntinf.ascent+fntinf.descent+1,
							Frame().IntegerWidth()-4,Frame().IntegerHeight()-4), 
						"", B_FOLLOW_ALL, B_WILL_DRAW);
	AddChild(innerView);
	innerView->SetViewColor(parent->ViewColor());
	innerView->SetFontName("Emily");
}

void BBorder :: Draw(BRect updateRect)
{
	BRect rect;
	font_info fntinf;
	
	GetFontInfo(&fntinf);
	
	rect=Frame();
	rect.OffsetTo(B_ORIGIN);
	rect.top=fntinf.ascent/2;
	rect.bottom-=1;
	rect.right-=1;
	
	SetHighColor(0,0,0);
	StrokeRect(rect);


	rect=Frame();
	rect.OffsetTo(B_ORIGIN);
	rect.top=fntinf.ascent/2;
	rect.top+=1;
	rect.left+=1;
	
	SetHighColor(255,255,255);
	StrokeRect(rect);


	if((Frame().IntegerWidth()>begin*2+textLen) 
		&& (Frame().IntegerHeight()>fntinf.ascent+fntinf.descent))
	{
		SetHighColor(ViewColor());

		rect.Set(begin,0,begin+textLen,fntinf.ascent+fntinf.descent-1);
		FillRect(rect);
	
		SetHighColor(0,0,0);
		SetLowColor(ViewColor());
		DrawString(label, BPoint(10,fntinf.ascent));
	}
}
