#include "BGauge.h"

BGauge :: BGauge(BRect frame, const char *name, ulong resizingMode, double m)
	: BView(frame, name, resizingMode, B_WILL_DRAW|B_FULL_UPDATE_ON_RESIZE), maxVal(m)
{
	if(maxVal<=0) maxVal=1;
	curVal=0;
}

void BGauge :: SetCurrentValue(long v)
{
	if(v!=curVal)
	{
		curVal=v;
		if(curVal<0) curVal=0;
		if(curVal>maxVal) curVal=maxVal;
		Invalidate();
	}
}

void BGauge :: Draw(BRect updateRect)
{
	rgb_color col={0, 0, 0, 0};
	BRect rect=Frame();
	
	BeginLineArray(12);

	col.red = 180; col.green = 180 ; col.blue = 180;
	AddLine(BPoint(0,0), BPoint(rect.IntegerWidth(),0), col);
	AddLine(BPoint(0,0), BPoint(0,rect.IntegerHeight()), col);

	AddLine(BPoint(2,rect.IntegerHeight()-1),BPoint(rect.IntegerWidth()-1,rect.IntegerHeight()-1), col);
	AddLine(BPoint(rect.IntegerWidth()-1,2),BPoint(rect.IntegerWidth()-1,rect.IntegerHeight()-1), col);

	col.red = 100; col.green = 100 ; col.blue = 100;
	AddLine(BPoint(1,1),BPoint(rect.IntegerWidth()-1,1), col);
	AddLine(BPoint(1,1),BPoint(1,rect.IntegerHeight()-1), col);
	
	long length=(curVal*(rect.IntegerWidth()-6))/maxVal;

	if(length>0)
	{
		long right=length+3;
		
		SetHighColor(51,152,255);
		FillRect(BRect(3,3,right,rect.IntegerHeight()-3));
		
		col.red = 152; col.green = 203 ; col.blue = 255;
		AddLine(BPoint(2,2),BPoint(right,2), col);
		AddLine(BPoint(2,2),BPoint(2,rect.IntegerHeight()-3), col);
		
		col.red = 0; col.green = 102 ; col.blue = 152;
		AddLine(BPoint(2,rect.IntegerHeight()-2),BPoint(right+1,rect.IntegerHeight()-2), col);
		AddLine(BPoint(right+1,2),BPoint(right+1,rect.IntegerHeight()-2), col);
	}

	EndLineArray();
}
