#include "BInfoApp.h"
#include "BInfoSettingsFile.h"

#include "const.h"
#include "tools.h"

BInfoApp :: BInfoApp()
	: BApplication('BINF')
{
	// CREATION DU MENU PRINCIPAL
	BMenuItem *item;   
	BPopUpMenu *menu = new BPopUpMenu("", FALSE, FALSE);
   
	item = new BMenuItem("About " PRG_NAME "...", new BMessage(B_ABOUT_REQUESTED));
	item->SetTarget(this);
	menu->AddItem(item);
   
	item = new BMenuItem("Settings...", new BMessage(MMENU_SETTINGS), 'S');
	item->SetTarget(this);
	menu->AddItem(item);
      
	item = new BMenuItem("Quit", new BMessage(B_QUIT_REQUESTED), 'Q');
	item->SetTarget(this);
	menu->AddItem(item);
   
	SetMainMenu(menu);

	BInfoSettingsFile *loader = new BInfoSettingsFile();
	long value;
	float x,y,w;
	
	x = DEF_SETTWIN_X;
	y = DEF_SETTWIN_Y;

	// CREATION DE LA FENETRE SETTINGS	
	if(loader->OpenRead() == B_NO_ERROR)
	{
		if(loader->Read(SAVE_SETTWIN_X, &value) == B_NO_ERROR)
			x = value;

		if(loader->Read(SAVE_SETTWIN_Y, &value) == B_NO_ERROR)
			y = value;

		loader->Close();
	}
	BRect winrect(x, y, x + 200, y + 100);
	settingswin = new BInfoSettingsWin(winrect);


	x = DEF_MAINWIN_X;
	y = DEF_MAINWIN_Y;
	w = DEF_MAINWIN_W;

	// CREATION DE LA FENETRE PRINCIPALE
	if(loader->OpenRead() == B_NO_ERROR)
	{
		if(loader->Read(SAVE_MAINWIN_X, &value) == B_NO_ERROR)
			x = value;
			
		if(loader->Read(SAVE_MAINWIN_Y, &value) == B_NO_ERROR)
			y = value;

		if(loader->Read(SAVE_MAINWIN_W, &value) == B_NO_ERROR)
			w = value;
			
		loader->Close();
	}
	winrect.Set(x, y, x + w, y + 300);
	binfowin = new BInfoWin(winrect);
	
	delete loader;
	
	newDiskInfo = TRUE;
	binfowin->Init();
}

void BInfoApp :: AboutRequested()
{	
	MsgBox(PRG_ABOUT);
}

bool BInfoApp :: QuitRequested()
{
	saveSettings();
	return TRUE;
}

void BInfoApp :: VolumeMounted(long volid)
{
	MountUnmount();
}
   
void BInfoApp :: VolumeUnmounted(long volid)
{
	MountUnmount();
}

void BInfoApp :: MessageReceived(BMessage *message)
{
	switch(message->what) 
	{
		case MMENU_SETTINGS:
			settingswin->ShowMe();
			break;
		
		case MCUSTOM_SETTINGSCHANGED:
			binfowin->Lock();
			newDiskInfo=TRUE;	
			binfowin->Init();
			binfowin->Unlock();
			break;
			
		default:
			inherited::MessageReceived(message);
			break;	
	}
}

void BInfoApp :: MountUnmount()
{
	binfowin->SetPulseRate(0);
	binfowin->Lock();
	newDiskInfo=TRUE;	
	binfowin->Unlock();
	binfowin->SetPulseRate(1);
}

void BInfoApp :: saveSettings()
{
	BRect rect;
	BInfoSettingsFile *saver = new BInfoSettingsFile();

	if(saver->OpenSave() == B_NO_ERROR)
	{
		rect=binfowin->Frame();
		saver->Write(SAVE_MAINWIN_X, rect.left);
		saver->Write(SAVE_MAINWIN_Y, rect.top);
		saver->Write(SAVE_MAINWIN_W, rect.IntegerWidth());

		rect=settingswin->Frame();
		saver->Write(SAVE_SETTWIN_X, rect.left);
		saver->Write(SAVE_SETTWIN_Y, rect.top);
		
		saver->Close();
	}
	
	delete saver;
}
