#include "const.h"
#include "BInfoSettingsFile.h"

BInfoSettingsFile :: BInfoSettingsFile()
{
	app_info info;  
	if(be_app->GetAppInfo(&info) == B_NO_ERROR)
	{
		BFile file(info.ref);
		file.GetParent(&dir);
	}
}

long BInfoSettingsFile :: OpenRead()
{
	long res = B_ERROR;
	
	if(dir.Contains(SETTINGSFILE))
	{
		dir.GetFile(SETTINGSFILE, &file);
		res = file.Open(B_READ_ONLY);
	}
		
	return res;
}

long BInfoSettingsFile :: OpenSave()
{
	long res = B_NO_ERROR;
	
	if(!dir.Contains(SETTINGSFILE))
		res = dir.Create(SETTINGSFILE, &file);
		
	if(res == B_NO_ERROR)
	{
		dir.GetFile(SETTINGSFILE, &file);
		res = file.Open(B_EXCLUSIVE);
	}
	
	return res;
}

long BInfoSettingsFile :: Close()
{
	return file.Close();
}

long BInfoSettingsFile :: Read(long id, long *value)
{
	long len, res = B_NO_ERROR;
	void *x;
	
	x=file.FindResource(B_LONG_TYPE, id, &len);
	if(x && len==sizeof(long))
	{
		*value=*(long *)x;
		delete x;
	}
	else
		res = B_ERROR;
		
	return res;
}

long BInfoSettingsFile :: Write(long id, long value)
{
	file.RemoveResource(B_LONG_TYPE, id);
	return file.AddResource(B_LONG_TYPE, id, &value, sizeof(long));
}
