#ifndef _BINFOSETTINGSWIN_H_
#define _BINFOSETTINGSWIN_H_

#include "BPopUpButton.h"

class BInfoSettingsWin : public BWindow {

	long refreshRate;
	
	bool displayMachineInfo;
	bool displayScreenInfo;
	bool displaySystemInfo;
	bool displayDiskInfo;
	
	bool displayMemory;
	bool displaySems;
	bool displayPorts;
	bool displayThreads;
	bool displayTeams;

	BCheckBox *checkMachineInfo;
	BCheckBox *checkScreenInfo;
	BCheckBox *checkSystemInfo;
	BCheckBox *checkDiskInfo;
	
	BCheckBox *checkMemory;
	BCheckBox *checkSems;
	BCheckBox *checkPorts;
	BCheckBox *checkThreads;
	BCheckBox *checkTeams;
	
	BButton *createButton(BView *parent, BRect rect, const char* label, ulong type);
	BCheckBox *createCheckBox(BView *parent, BRect rect, const char* label, ulong type);
	BPopUpButton *refreshButton;
	
	void initSettings();
	void load();
	void save();
	bool settingsChanged();
	bool settingsOK();
	
public :
	BInfoSettingsWin(BRect);
	virtual void MessageReceived(BMessage *message);
	void ShowMe();

	bool DisplayMachineInfo() {return (displayMachineInfo==B_CONTROL_ON);}
	bool DisplayScreenInfo() {return (displayScreenInfo==B_CONTROL_ON);}
	bool DisplaySystemInfo() {return (displaySystemInfo==B_CONTROL_ON);}
	bool DisplayDiskInfo() {return (displayDiskInfo==B_CONTROL_ON);}
	
	bool DisplayMemory() {return (displayMemory==B_CONTROL_ON);}
	bool DisplaySems() {return (displaySems==B_CONTROL_ON);}
	bool DisplayPorts() {return (displayPorts==B_CONTROL_ON);}
	bool DisplayThreads() {return (displayThreads==B_CONTROL_ON);}
	bool DisplayTeams() {return (displayTeams==B_CONTROL_ON);}
	
	long RefreshRate();
};

#endif