#include "BInfoApp.h"
#include "BInfoWin.h"
#include "BInfoSettingsWin.h"

#include "const.h"
#include "tools.h"

BInfoWin :: BInfoWin(BRect rect)
	: BWindow(rect, "BInfo", B_TITLED_WINDOW, B_NOT_V_RESIZABLE)
{
	binfoview = NULL;
}

void BInfoWin :: Init()
{
	Lock();
	SetDiscipline(FALSE);

	if(binfoview)
	{
		RemoveChild(binfoview);
		delete(binfoview);
	}
		
	// CREATION DE LA BVIEW PRINCIPALE
	BRect winrect(Frame());
	winrect.OffsetTo(B_ORIGIN);
	binfoview = new BInfoView(this, winrect);
	binfoview->Init();
	
	if(IsHidden())
	{
		screen_info scrinf;
		get_screen_info(&scrinf);

		if(    Frame().left < 0
			|| Frame().right > scrinf.frame.IntegerWidth()
			|| Frame().top < 0
			|| Frame().bottom > scrinf.frame.IntegerHeight())
			MoveTo(DEF_MAINWIN_X, DEF_MAINWIN_Y);

		Show();
	}
	
	Unlock();
}

bool BInfoWin :: QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return FALSE;
}

void BInfoWin :: Zoom(BPoint leftTop, float width, float height) 
{
	long ht = binfoview->Frame().bottom;
	
	SetSizeLimits(DEF_MAINWIN_W, 1024, ht, ht);
	ResizeTo(DEF_MAINWIN_W, ht);
}

void BInfoWin :: ZoomMe()
{
	long ht = binfoview->Frame().bottom;
	
	SetSizeLimits(DEF_MAINWIN_W, 1024, ht, ht);
	ResizeTo(Frame().IntegerWidth(), ht);
}

void BInfoWin :: ScreenChanged(BRect frame, color_space mode)
{
	binfoview->DisplayDynamicScreenInfo();
}

void BInfoWin :: WorkspacesChanged(ulong oldWorkspaces, ulong newWorkspaces)
{
	binfoview->DisplayDynamicScreenInfo();
}
