#include "DiskView.h"
#include "tools.h"

DiskView :: DiskView(BView *parent, BRect frame, const char *name, ulong resizingMode, int u)
	: BView(frame, name, resizingMode, B_WILL_DRAW)
{
	BRect rect;
	BVolume this_vol; 
	char str[256];
	int isrdonly, isremovable;
	
	parent->AddChild(this);
	SetViewColor(parent->ViewColor());

	unit = u;
	first=TRUE;
	
	this_vol = volume_at(unit);
	capacity = this_vol.Capacity();
	sprintMem(capacity_str, capacity);

	if(this_vol.Error() == B_NO_ERROR)
	{
		rect=Frame();
		rect.OffsetTo(B_ORIGIN);
		textes = new LabeledText(this, rect, "", B_FOLLOW_LEFT_RIGHT, 67);
		textes->SetFontName("Erich");
		textes->SetFontSize(10);
	
		textes->AddLabel("Volume name :");
		textes->AddLabel("Device name :");
		textes->AddLabel("Used space :");
		textes->CreateLabels();

		isrdonly = this_vol.IsReadOnly();
		isremovable = this_vol.IsRemovable();
		
		this_vol.GetName(str);
		
		if(isrdonly || isremovable)
		{
			strcat(str, " (");
			if(isrdonly) strcat(str, "read only");
			if(isremovable)
			{
				if(isrdonly) strcat(str, ", ");
				strcat(str, "removable");
			}
			strcat(str,")");
		}
		
		textes->SetText(0, str);

		this_vol.GetDevice(str);
		textes->SetText(1, str);
		
		rect.Set(0, 0, Frame().IntegerWidth(), 15);
		rect.OffsetTo(0, textes->Frame().bottom);		
		gauge = new BGauge(rect, "", B_FOLLOW_LEFT_RIGHT, capacity);
		AddChild(gauge);

		ResizeTo(Frame().IntegerWidth(), gauge->Frame().bottom);
		
		Update();
	}
}

void DiskView :: Update()
{
	char str[256],mem_used[20];
	BVolume this_vol;
	
	this_vol = volume_at(unit);

	if(this_vol.Error() == B_NO_ERROR)
	{	
		if(first || (floor(free)!=floor(this_vol.FreeBytes())))
		{
			free = this_vol.FreeBytes();
	
			sprintMem(mem_used, capacity - free);	
			sprintf(str,"%s / %s", mem_used, capacity_str);
			textes->SetText(2, str);
			
			gauge->SetCurrentValue(capacity - free);
		}
	}
	
	first = FALSE;
}
