#include "LabeledText.h"
#include "LabeledText.h"

LabeledText :: LabeledText(BView *parent, BRect frame, const char *name, ulong resizingMode, float w)
	: BView(frame, name, resizingMode, B_WILL_DRAW)
{
	parent->AddChild(this);
	SetViewColor(parent->ViewColor());
	
	width=w;
	curTop=0;
	fontHeight=0;
}

void LabeledText :: AddLabel(char *label)
{
	labels.AddItem(label);
}

void LabeledText :: CreateLabels()
{
	int cnt=labels.CountItems();
	BStringView *text;
	BRect rect;
	font_info fntinf;

	GetFontInfo(&fntinf);
	fontHeight=fntinf.ascent+fntinf.descent+fntinf.leading;
	
	for(int i=0; i<cnt; i++)
	{	
		rect.Set(0, curTop, width, curTop + fontHeight);
		text = new BStringView(rect, "", (char *)labels.ItemAt(i));
		text->SetAlignment(B_ALIGN_RIGHT);
		text->SetViewColor(ViewColor());
		text->SetFontName(fntinf.name);
		text->SetFontSize(fntinf.size);
		AddChild(text);
		
		rect.Set(width+1, curTop, Frame().IntegerWidth(), curTop + fontHeight);
		text = new BStringView(rect, "", "", B_FOLLOW_LEFT_RIGHT);
		text->SetAlignment(B_ALIGN_LEFT);
		text->SetViewColor(ViewColor());
		text->SetFontName(fntinf.name);
		text->SetFontSize(fntinf.size);
		AddChild(text);
		
		textviews.AddItem(text);
		
		curTop += fontHeight + 1;
	}	
	ResizeTo(Frame().IntegerWidth(), curTop);
}

void LabeledText :: SetText(int index, char *text)
{
	BStringView *view=(BStringView *)textviews.ItemAt(index);
	
	if(view)
		view->SetText(text);
}
